## gross 1.1.0~a1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

if(POLICY CMP0127)
  cmake_policy(SET CMP0127 NEW)
endif()

project(
  gross
  VERSION 1.1.0
  LANGUAGES C
  )

set(VERSION_SUFFIX ~a1)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(GNUInstallDirs)
include(CTest)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckSymbolExists)
include(CheckTypeSize)
include(CMakeDependentOption)

if(NOT CMAKE_C_BYTE_ORDER)
  # cmake < 3.20
  include(TestBigEndian)
  test_big_endian(BIG_ENDIAN)
endif()

if(CMAKE_C_BYTE_ORDER STREQUAL "BIG_ENDIAN" OR BIG_ENDIAN)
  add_compile_definitions(BIG_ENDIAN)
endif()

if(CMAKE_C_BYTE_ORDER STREQUAL "LITTLE_ENDIAN" OR NOT CMAKE_C_BYTE_ORDER AND NOT BIG_ENDIAN)
  add_compile_definitions(LITTLE_ENDIAN)
endif()

find_library(MATH_LIBRARY m DOC "standard math library")

find_package(Threads REQUIRED)
if(NOT CMAKE_USE_PTHREADS_INIT)
  message(SEND_ERROR "POSIX threads not found")
endif()

find_file(NETINET_IN_H "netinet/in.h")
if(NETINET_IN_H)
  add_compile_definitions(HAVE_NETINET_IN_H)
endif()

check_symbol_exists(clock_gettime "time.h" HAVE_CLOCK_GETTIME)
check_symbol_exists(CLOCK_MONOTONIC "time.h" HAVE_CLOCK_MONOTONIC)
check_symbol_exists(CLOCK_HIRES "time.h" HAVE_CLOCK_HIRES)
check_symbol_exists(CLOCK_REALTIME "time.h" HAVE_CLOCK_REALTIME)
check_symbol_exists(gettimeofday "sys/time.h" HAVE_GETTIMEOFDAY)

if(HAVE_CLOCK_GETTIME)
  if(HAVE_CLOCK_MONOTONIC)
    add_compile_definitions(USE_CLOCK_MONOTONIC)
  elseif(HAVE_CLOCK_HIRES)
    add_compile_definitions(USE_CLOCK_HIRES)
  elseif(HAVE_CLOCK_REALTIME)
    add_compile_definitions(USE_CLOCK_REALTIME)
  elseif(HAVE_GETTIMEOFDAY)
    add_compile_definitions(USE_GETTIMEOFDAY)
  else()
    message(SEND_ERROR "no suitable clock type found")
  endif()
elseif(HAVE_GETTIMEOFDAY)
  add_compile_definitions(USE_GETTIMEOFDAY)
else()
  message(SEND_ERROR "no suitable clock type found")
endif()

set(CMAKE_REQUIRED_INCLUDES "semaphore.h")
set(CMAKE_REQUIRED_LIBRARIES Threads::Threads)
check_function_exists(sem_init HAVE_SEM_INIT)
check_function_exists(sem_open HAVE_SEM_OPEN)
unset(CMAKE_REQUIRED_INCLUDES)
unset(CMAKE_REQUIRED_LIBRARIES)

if(HAVE_SEM_INIT)
elseif(HAVE_SEM_OPEN)
  add_compile_definitions(USE_SEM_OPEN)
else()
  message(SEND_ERROR "cannot compile without semaphores")
endif()

check_include_file("stdbool.h" HAVE_STDBOOL_H)
if(HAVE_STDBOOL_H)
  add_compile_definitions(HAVE_STDBOOL_H)
endif()

set(CMAKE_EXTRA_INCLUDE_FILES "stdbool.h")

check_type_size(bool BOOL)
if(HAVE_BOOL)
  add_compile_definitions(HAVE_BOOL)
endif()

check_include_file("stdatomic.h" HAVE_STDATOMIC_H)
if(HAVE_STDATOMIC_H)
  set(CMAKE_EXTRA_INCLUDE_FILES "stdatomic.h")
  check_type_size(atomic_bool ATOMIC_BOOL)
  if(HAVE_ATOMIC_BOOL)
    add_compile_definitions(HAVE_ATOMIC_BOOL)
  else()
    message(SEND_ERROR "type atomic_bool not defined")
  endif()
else()
  message(SEND_ERROR "stdatomic.h not found")
endif()

unset(CMAKE_EXTRA_INCLUDE_FILES)

set(CMAKE_EXTRA_INCLUDE_FILES "unistd.h")

check_type_size(useconds_t USECONDS_T)
if(HAVE_USECONDS_T)
  add_compile_definitions(HAVE_USECONDS_T)
endif()

unset(CMAKE_EXTRA_INCLUDE_FILES)

find_package(c-ares)
find_package(Milter)
find_package(LibSpf2)
find_package(Asciidoctor)

if(NOT Asciidoctor_FOUND)
  message(WARNING "asciidoctor not found, manual pages will not be built")
endif()

cmake_dependent_option(DNSBL "Enable DNSBL checking" ON c-ares_FOUND OFF)
cmake_dependent_option(SPF "Enable SPF checking" ON LibSpf2_FOUND OFF)
cmake_dependent_option(MILTER "Enable milter support" ON Milter_FOUND OFF)
cmake_dependent_option(BUILD_DOCS "Build documentation" ON Asciidoctor_FOUND OFF)

if(DNSBL)
  add_compile_definitions(DNSBL)
endif()

if(MILTER)
  add_compile_definitions(MILTER)
endif()

if(SPF)
  add_compile_definitions(SPF)
endif()

add_compile_definitions(
  CONFIGFILE=\"${CMAKE_INSTALL_FULL_SYSCONFDIR}/grossd.conf\"
  VERSION=\"${CMAKE_PROJECT_VERSION}${VERSION_SUFFIX}\"
  )

add_subdirectory("src")
add_subdirectory("man")

install(FILES doc/examples/grossd.conf
  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}
  )

=== man/CMakeLists.txt ===
list(APPEND DOC_ATTRIBUTES
  "libdir=${CMAKE_INSTALL_FULL_LIBDIR}/${PROJECT_NAME}"
  "sysconfdir=${CMAKE_INSTALL_FULL_SYSCONFDIR}"
  )

if(NOT DNSBL)
  list(APPEND DOC_ATTRIBUTES no-dnsbl)
endif()

if(NOT MILTER)
  list(APPEND DOC_ATTRIBUTES no-milter)
endif()

if(NOT SPF)
  list(APPEND DOC_ATTRIBUTES no-spf)
endif()

function(gross_add_man _name _sect)
  asciidoctor_add_document("${_name}.${_sect}"
    SOURCE "${_name}.${_sect}.adoc"
    BACKEND manpage
    TYPE manpage
    ATTRIBUTES ${DOC_ATTRIBUTES}
    )

  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${_name}.${_sect}"
    DESTINATION "${CMAKE_INSTALL_MANDIR}/man${_sect}"
    )
endfunction()

if(BUILD_DOCS)
  gross_add_man(grossd 8)
  gross_add_man(grossd.conf 5)
endif()

=== src/CMakeLists.txt ===
include_directories("${CMAKE_SOURCE_DIR}/include")

set(grossd_OPTIONAL_SOURCES)

if(DNSBL)
  list(APPEND grossd_OPTIONAL_SOURCES
    check_dnsbl.c
    check_helo.c
    check_reverse.c
    helper_dns.c
    )
endif()

if(MILTER)
  list(APPEND grossd_OPTIONAL_SOURCES
    worker_milter.c
    )
endif()

if(SPF)
  list(APPEND grossd_OPTIONAL_SOURCES
    check_spf.c
    )
endif()

add_executable(grossd
  addrutils.c
  bloom.c
  bloommgr.c
  check_blocker.c
  check_random.c
  conf.c
  gross.c
  lookup3.c
  msgqueue.c
  proto_sjsms.c
  sha256.c
  srvstatus.c
  srvutils.c
  stats.c
  syncmgr.c
  thread_pool.c
  utils.c
  worker.c
  worker_postfix.c
  worker_sjsms.c
  ${grossd_OPTIONAL_SOURCES}
  )

target_link_libraries(grossd
  ${MATH_LIBRARY}
  Threads::Threads
  )

if(DNSBL)
  target_link_libraries(grossd c-ares::cares)
endif()

if(MILTER)
  target_link_libraries(grossd Sendmail::milter)
endif()

if(SPF)
  target_link_libraries(grossd LibSpf2::spf2)
endif()

install(TARGETS grossd
  DESTINATION ${CMAKE_INSTALL_SBINDIR}
  )

add_executable(gclient
  client_postfix.c
  client_sjsms.c
  gclient.c
  proto_sjsms.c
  utils.c
  )

add_library(grosscheck MODULE
  grosscheck.c
  proto_sjsms.c
  )
set_property(TARGET grosscheck
  PROPERTY PREFIX ""
  )
install(TARGETS grosscheck
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/${PROJECT_NAME}
  )

if(BUILD_TESTING)

  add_executable(bloom
    bloom-test.c
    bloom.c
    sha256.c
    srvutils.c
    utils.c
    )
  target_link_libraries(bloom
    ${MATH_LIBRARY}
    Threads::Threads
    )
  add_test(bloom bloom)

  add_executable(counter
    bloom.c
    counter-test.c
    counter.c
    srvutils.c
    utils.c
    )
  target_link_libraries(counter
    ${MATH_LIBRARY}
    Threads::Threads
    )
  add_test(counter counter)

  if(DNSBL)
    add_executable(helper_dns
      bloom.c
      helper_dns-test.c
      helper_dns.c
      lookup3.c
      msgqueue.c
      srvutils.c
      utils.c
      )
    target_link_libraries(helper_dns
      ${MATH_LIBRARY}
      c-ares::cares
      Threads::Threads
      )
    add_test(helper_dns helper_dns)
    set_property(
      TEST helper_dns
      PROPERTY LABELS net
      )
  endif()

  add_executable(mask
    addrutils.c
    bloom.c
    mask-test.c
    srvutils.c
    utils.c
    )
  target_link_libraries(mask
    ${MATH_LIBRARY}
    Threads::Threads
    )
  add_test(mask mask)

  add_executable(msgqueue
    bloom.c
    msgqueue-test.c
    msgqueue.c
    srvutils.c
    utils.c
    )
  target_link_libraries(msgqueue
    ${MATH_LIBRARY}
    Threads::Threads
    )
  add_test(msgqueue msgqueue)

  add_executable(revaddr
    addrutils.c
    bloom.c
    reverse_ip-test.c
    srvutils.c
    utils.c
    )
  target_link_libraries(revaddr
    ${MATH_LIBRARY}
    Threads::Threads
    )
  add_test(revaddr revaddr)

  add_executable(sha256
    bloom.c
    sha256-test.c
    sha256.c
    srvutils.c
    utils.c
    )
  target_link_libraries(sha256
    ${MATH_LIBRARY}
    Threads::Threads
    )
  add_test(sha256 sha256)

endif(BUILD_TESTING)

## gross 1.0.2

=== debian/changelog ===
gross (1.0.2-2) unstable; urgency=low

  * debian/rules: updating config.{sub,guess} (Closes: 583762)
  * debian/README.Debian and debian/control modified to note that Sendmail 
    is supported (Closes: 584597)

 -- Antonio Radici <antonio@dyne.org>  Mon, 07 Jun 2010 16:36:30 +0100

gross (1.0.2-1) unstable; urgency=low

  * Initial release (Closes: 548972)

 -- Antonio Radici <antonio@dyne.org>  Mon, 17 May 2010 21:34:46 +0100

=== debian/control ===
Source: gross
Section: mail
Priority: extra
Maintainer: Antonio Radici <antonio@dyne.org>
Build-Depends: debhelper (>= 7.0.50~), autotools-dev, libc-ares-dev
Standards-Version: 3.8.4
Homepage: http://code.google.com/p/gross/
Vcs-Git: git://git.debian.org/collab-maint/gross.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/gross.git;a=summary

Package: gross
Architecture: any
Depends: adduser, postfix | exim4-daemon-light | exim4-daemon-heavy | sendmail,
 ${shlibs:Depends}, ${misc:Depends}
Description: fast and efficient greylist server with DNSBL support
 Gross is a resource efficient greylist server written in C that supports
 greylisting and/or blocking based on DNSRBL so it will not impact legitimate
 mails
 .
 It also contains a milter implementation and natively supports Postfix,
 Exim and Sendmail.

=== debian/rules ===
#!/usr/bin/make -f
# vim:noet:
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh  $@
override_dh_auto_configure:
	cp -f /usr/share/misc/config.sub config.sub
	cp -f /usr/share/misc/config.guess config.guess
	dh_auto_configure
	
override_dh_install:
	dh_install
	# some static/shared libraries, not really needed
	rm -rf debian/gross/usr/lib
	# a binary used only for testing
	rm debian/gross/usr/bin/gclient
	rmdir debian/gross/usr/bin

override_dh_clean:
	rm -f config.{guess,sub}

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format

# because uscan doesn't work with code.google.com ATM
version=3
opts=\
downloadurlmangle=s|.*[?]name=(.*?)&.*|http://gross.googlecode.com/files/$1|,\
filenamemangle=s|[^/]+[?]name=(.*?)&.*|$1| \
http://code.google.com/p/gross/downloads/detail[?]name=gross-([0-9.]+).tar.gz&.*

## gross 1.0.4

=== debian/changelog ===
gross (1.0.4-1) unstable; urgency=medium

  * QA upload.
    Closes: #1107872

  [ Jelmer Vernooĳ ]
  * Migrate repository from alioth to salsa.

  [ Andreas Tille ]
  * New upstream version (Fixes CVE-2023-52159)
    Closes: #1105382
  * Fix Homepage
    Closes: #981690
  * Fix watch file
  * Standards-Version: 4.7.2
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Update renamed lintian tag names in lintian overrides.
  * Fix prototypes to build properly with gcc-15
    Closes: #1039214
  * Add systemd service
    Closes: #1039214
  * d/copyright: Fix Upstream-Source

  [ Tj ]
  * Fix autoconf bit-rot
  * Fix automake declarations
  * Fix compiler warning
  * Create /etc if not existing

 -- Andreas Tille <tille@debian.org>  Thu, 28 Aug 2025 11:53:21 +0200

gross (1.0.2-4) unstable; urgency=low

  * debian/README: fixed a typo (Closes: 670596)
  * debian/patches/0003-change-default-user.patch:
    + use 'gross' as default user (Closes: 620368, 614790)
  * debian/rules:
    + enable milter when building the package (Closes: 620367)
    + hardening enabled by using a higher dh version
  * debian/control:
    + switched my email to debian.org
    + bumped Standards-Version to 3.9.6, no changes required
    + bumped DH to >= 9

 -- Antonio Radici <antonio@debian.org>  Sat, 25 Oct 2014 08:04:36 +0000

gross (1.0.2-3) unstable; urgency=low

  * debian/source/options: ignoring our changes to config.{sub,guess}
    (Closes: 643146).
  * debian/rules: removed the override_dh_clean section due to the above
    changes.
  * debian/control:
    + Standards-Version bumped to 3.9.3, no change required.
    + switched my mail to antonio@debian.org.

 -- Antonio Radici <antonio@debian.org>  Mon, 19 Mar 2012 20:24:53 +0000

=== debian/control ===
Source: gross
Maintainer: Debian QA Group <packages@qa.debian.org>
Section: mail
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libc-ares-dev
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/debian/gross
Vcs-Git: https://salsa.debian.org/debian/gross.git
Homepage: https://codeberg.org/bizdelnick/gross
Rules-Requires-Root: no

Package: gross
Architecture: any
Depends: adduser,
         postfix | exim4-daemon-light | exim4-daemon-heavy | sendmail,
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: fast and efficient greylist server with DNSBL support
 Gross is a resource efficient greylist server written in C that supports
 greylisting and/or blocking based on DNSRBL so it will not impact legitimate
 mails
 .
 It also contains a milter implementation and natively supports Postfix,
 Exim and Sendmail.

=== debian/rules ===
#!/usr/bin/make -f
# vim:noet:

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh  $@

override_dh_auto_configure:
	cp -f /usr/share/misc/config.sub config.sub
	cp -f /usr/share/misc/config.guess config.guess
	dh_auto_configure -- --with-milter

override_dh_install:
	dh_install
	# some static/shared libraries, not really needed
	rm -rf debian/gross/usr/lib
	# a binary used only for testing
	rm debian/gross/usr/bin/gclient
	rmdir debian/gross/usr/bin

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/@PACKAGE@-$1\.tar\.gz/ \
  https://codeberg.org/bizdelnick/gross/tags .*/v?(\d[\d.]+)\.tar\.gz
